package com.fp.persistence.pgeneral.auth;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENEEXCEPTIONS*/
@Embeddable
public class TgeneExceptionsKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="MODULECODE", nullable=false,updatable=false)

/**
* Codigo de modulo
*/
private String modulecode;

@Column(name="PRODUCTCODE", nullable=false,updatable=false)

/**
* Codigo de producto
*/
private String productcode;

@Column(name="SUBPRODUCTCODE", nullable=false,updatable=false)

/**
* Codigo de subproducto
*/
private String subproductcode;

@Column(name="CURRENCYCODE", nullable=false,updatable=false)

/**
* Codigo de moneda
*/
private String currencycode;

@Column(name="BEAN", nullable=false,updatable=false)

/**
* Bean del cual se obtiene el valor del atributo a evaluar 
*/
private String bean;

@Column(name="ATTRIBUTE", nullable=false,updatable=false)

/**
* Atributo a obtener el valor para aplicar la condicion y comparar con el dato del campo valor
*/
private String attribute;

@Column(name="EXCEPTIONORDER", nullable=false,updatable=false)

/**
* Orden de generacion de autorizaciones
*/
private Integer exceptionorder;

/**Contructor por defecto*/
public TgeneExceptionsKey(){}
/**Contructor de TgeneExceptionsKey
@param pModulecode Codigo de modulo
@param pProductcode Codigo de producto
@param pSubproductcode Codigo de subproducto
@param pCurrencycode Codigo de moneda
@param pBean Bean del cual se obtiene el valor del atributo a evaluar 
@param pAttribute Atributo a obtener el valor para aplicar la condicion y comparar con el dato del campo valor
@param pExceptionorder Orden de generacion de autorizaciones
*/
public TgeneExceptionsKey(String pModulecode,String pProductcode,String pSubproductcode,String pCurrencycode,String pBean,String pAttribute,Integer pExceptionorder){
 modulecode=pModulecode;
 productcode=pProductcode;
 subproductcode=pSubproductcode;
 currencycode=pCurrencycode;
 bean=pBean;
 attribute=pAttribute;
 exceptionorder=pExceptionorder;
}
/**Obtiene el valor de modulecode
@return valor de modulecode*/
public String getModulecode(){
  return modulecode;
}
/**Fija el valor de modulecode
@param pModulecode nuevo Valor de modulecode*/
public void setModulecode(String pModulecode){
  modulecode=pModulecode;
}

/**Obtiene el valor de productcode
@return valor de productcode*/
public String getProductcode(){
  return productcode;
}
/**Fija el valor de productcode
@param pProductcode nuevo Valor de productcode*/
public void setProductcode(String pProductcode){
  productcode=pProductcode;
}

/**Obtiene el valor de subproductcode
@return valor de subproductcode*/
public String getSubproductcode(){
  return subproductcode;
}
/**Fija el valor de subproductcode
@param pSubproductcode nuevo Valor de subproductcode*/
public void setSubproductcode(String pSubproductcode){
  subproductcode=pSubproductcode;
}

/**Obtiene el valor de currencycode
@return valor de currencycode*/
public String getCurrencycode(){
  return currencycode;
}
/**Fija el valor de currencycode
@param pCurrencycode nuevo Valor de currencycode*/
public void setCurrencycode(String pCurrencycode){
  currencycode=pCurrencycode;
}

/**Obtiene el valor de bean
@return valor de bean*/
public String getBean(){
  return bean;
}
/**Fija el valor de bean
@param pBean nuevo Valor de bean*/
public void setBean(String pBean){
  bean=pBean;
}

/**Obtiene el valor de attribute
@return valor de attribute*/
public String getAttribute(){
  return attribute;
}
/**Fija el valor de attribute
@param pAttribute nuevo Valor de attribute*/
public void setAttribute(String pAttribute){
  attribute=pAttribute;
}

/**Obtiene el valor de exceptionorder
@return valor de exceptionorder*/
public Integer getExceptionorder(){
  return exceptionorder;
}
/**Fija el valor de exceptionorder
@param pExceptionorder nuevo Valor de exceptionorder*/
public void setExceptionorder(Integer pExceptionorder){
  exceptionorder=pExceptionorder;
}

/**Implementación de la comparación de TgeneExceptionsKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneExceptionsKey))return false;
  TgeneExceptionsKey that = (TgeneExceptionsKey) o;
  if (this.getModulecode() == null || that.getModulecode() == null){
      return false;
  }
  if (! this.getModulecode().equals(that.getModulecode())){
    return false;
  }
  if (this.getProductcode() == null || that.getProductcode() == null){
      return false;
  }
  if (! this.getProductcode().equals(that.getProductcode())){
    return false;
  }
  if (this.getSubproductcode() == null || that.getSubproductcode() == null){
      return false;
  }
  if (! this.getSubproductcode().equals(that.getSubproductcode())){
    return false;
  }
  if (this.getCurrencycode() == null || that.getCurrencycode() == null){
      return false;
  }
  if (! this.getCurrencycode().equals(that.getCurrencycode())){
    return false;
  }
  if (this.getBean() == null || that.getBean() == null){
      return false;
  }
  if (! this.getBean().equals(that.getBean())){
    return false;
  }
  if (this.getAttribute() == null || that.getAttribute() == null){
      return false;
  }
  if (! this.getAttribute().equals(that.getAttribute())){
    return false;
  }
  if (this.getExceptionorder() == null || that.getExceptionorder() == null){
      return false;
  }
  if (! this.getExceptionorder().equals(that.getExceptionorder())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneExceptionsKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getModulecode() == null ? 0 : this.getModulecode().hashCode());
    result = result * 37 + (this.getProductcode() == null ? 0 : this.getProductcode().hashCode());
    result = result * 37 + (this.getSubproductcode() == null ? 0 : this.getSubproductcode().hashCode());
    result = result * 37 + (this.getCurrencycode() == null ? 0 : this.getCurrencycode().hashCode());
    result = result * 37 + (this.getBean() == null ? 0 : this.getBean().hashCode());
    result = result * 37 + (this.getAttribute() == null ? 0 : this.getAttribute().hashCode());
    result = result * 37 + (this.getExceptionorder() == null ? 0 : this.getExceptionorder().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
